const dataURItoBlobURL = function(dataURI) {
    // convert base64 to raw binary data held in a string
    let byteString = atob(dataURI.split(',')[1]);

    // separate out the mime component
    let mimeString = dataURI.split(',')[0].split(':')[1].split(';')[0];

    // write the bytes of the string to an ArrayBuffer
    let arrayBuffer = new ArrayBuffer(byteString.length);
    let _ia = new Uint8Array(arrayBuffer);
    for (let i = 0; i < byteString.length; i++) {
        _ia[i] = byteString.charCodeAt(i);
    }

    let dataView = new DataView(arrayBuffer);
    let blob = new Blob([dataView], { type: mimeString });
    let url = window.URL.createObjectURL(blob);
    return url;
}

const revokeBlob = function(blobURL){
  if(blobURL != undefined){
    if(blobURL.search('blob') > -1){
      window.URL.revokeObjectURL(blobURL);
    }
  }
}
